function [z w] = drrng_init_hyp(p_ref,x00,r,r_hyp,h_hyp,chi_hyp,theta_hyp)

% Base hypothesis
r_hyp2 = r + r_hyp;%[-0.5 0.2 0 0.2 0.5];
% h_hyp = [-0.5 0 0.5];
% dori = 10;
% chi_hyp = (0:dori:360-dori)'*pi/180;
% theta_hyp = (0:dori:360-dori)'*pi/180;

% Precalculate trigonometric functions
cos_chin = cos(chi_hyp);
sin_chin = sin(chi_hyp);
cos_thetam = cos(theta_hyp);
sin_thetam = sin(theta_hyp);

% Number of hypthesis
Ni = numel(h_hyp);
Nj = numel(r_hyp2);
Nn = numel(chi_hyp);
Nm = numel(theta_hyp);
N = Ni*Nj*Nn*Nm;

z = zeros(6,N);
w = 1/N*ones(1,N);
x_ref=[p_ref; 0];
for i = 1:Ni
    ii = (i-1)*Nj*Nn*Nm;
    for j = 1:Nj
        jj = (j-1)*Nn*Nm;
        for n = 1:Nn
            nn = (n-1)*Nm;
            rij = sqrt(abs( r_hyp2(j)^2-(p_ref(3)-x00(3)-h_hyp(i))^2 ));
            rijn = [rij*cos_chin(n);rij*sin_chin(n);p_ref(3)-x00(3)-h_hyp(i);0];
            for m = 1:Nm
                ind = ii+jj+nn+m;
                Hm = [cos_thetam(m) -sin_thetam(m) 0 0;
                      sin_thetam(m) cos_thetam(m)  0 0;
                      0             0              1 0];
%                 theta_z = [0 0 0 theta_hyp(m)+x00(4)]'; % This is strange. Write in a better way.
                rm = [Hm*x00;-theta_hyp(m)];
                z(1:4,ind) = x_ref - rijn - rm;%Rm*x00 + theta_z;
                z(5,ind)=cos_thetam(m);
                z(6,ind)=sin_thetam(m);
            end
        end
    end
end

return