function [z w] = init_hyp(x_ref,x,r,x0,dori)

% State estimates
R0 = [cos(x0(4)) -sin(x0(4)) 0 0;
      sin(x0(4)) cos(x0(4))  0 0;
      0          0           1 0;
      0          0           0 1];

% Base hypothesis
hi = [-0.5 0 0.5];
rj = r+[-0.5 0.2 0 0.2 0.5];
%dori = 10;
chin = (0:dori:360-dori)'*pi/180;
thetam = (0:dori:360-dori)'*pi/180;
% Precalculate trigonometric functions
cos_chin = cos(chin);
sin_chin = sin(chin);
cos_thetam = cos(thetam);
sin_thetam = sin(thetam);

% Number of hypthesis
Ni = numel(hi);
Nj = numel(rj);
Nn = numel(chin);
Nm = numel(thetam);
N = Ni*Nj*Nn*Nm;
%disp(N)

z = zeros(6,N);
w = 1/N*ones(1,N);
x00 = R0*(x-x0);
for i = 1:Ni
    ii = (i-1)*Nj*Nn*Nm;
%    h = [0 0 hi(i) 0]';
    for j = 1:Nj
        jj = (j-1)*Nn*Nm;
        for n = 1:Nn
            nn = (n-1)*Nm;
            rij = sqrt( rj(j)^2-(x_ref(3)-x00(3)-hi(i))^2 );
            rijn = [rij*cos_chin(n);rij*sin_chin(n);x_ref(3)-x00(3)-hi(i);0];
            for m = 1:Nm
                ind = ii+jj+nn+m;
                Rm = [cos_thetam(m) -sin_thetam(m) 0 0;
                      sin_thetam(m) cos_thetam(m)  0 0;
                      0             0              1 0;
                      0             0              0 1];
                theta_z = [0 0 0 thetam(m)]';
                z(1:4,ind) = x_ref - rijn - Rm*x00 + theta_z;% - h;
                z(5,ind)=cos_thetam(m);
                z(6,ind)=sin_thetam(m);
            end
        end
    end
end

return