function [x_out P_out] = swdrN_tud(x_in,P_in,dx,dP,s_nr) %#codegen

% Dimensionality
N = numel(x_in);

% Temporary variables
sin_phi = sin(x_in(s_nr+3));
cos_phi = cos(x_in(s_nr+3));

% Input matrix of id-system
T = [cos_phi -sin_phi 0 0;
     sin_phi  cos_phi 0 0;
     0        0       1 0;
     0        0       0 1];

% System matrix of id-system
F = [1 0 0 -sin_phi*dx(1)-cos_phi*dx(2);
     0 1 0 cos_phi*dx(1)-sin_phi*dx(2);
     0 0 1 0;
     0 0 0 1];

% Full system input and system matrix
T_sys = zeros(N,4);
T_sys(s_nr:s_nr+3,:) = T;
F_sys = eye(N);
F_sys(s_nr:s_nr+3,s_nr:s_nr+3) = F;

% Update system states
x_out = x_in+T_sys*dx;

% Update system covaraince
P_out = F_sys*P_in*F_sys' + T_sys*dP*T_sys';

end